var Container = require('./container');

// CSS at-rule like “this.keyframes name { }”.
//
// Can contain declarations (like this.font-face or this.page) ot another rules.
var AtRule = (function(super$0){var DP$0 = Object.defineProperty;var MIXIN$0 = function(t,s){for(var p in s){if(s.hasOwnProperty(p)){DP$0(t,p,Object.getOwnPropertyDescriptor(s,p));}}return t};"use strict";MIXIN$0(AtRule, super$0);
    function AtRule(defaults) {
        this.type = 'atrule';
        super$0.call(this, defaults);
    }AtRule.prototype = Object.create(super$0.prototype, {"constructor": {"value": AtRule, "configurable": true, "writable": true} });DP$0(AtRule, "prototype", {"configurable": false, "enumerable": false, "writable": false});

    // Different style for this.encoding and this.page at-rules.
    AtRule.prototype.styleType = function() {
        return this.type + ((this.rules || this.decls) ? '-body' : '-bodiless');
    }

    AtRule.prototype.defaultStyle = function(type) {
        if ( type == 'atrule-body' ) {
            return { between: ' ', after: this.defaultAfter() };
        } else {
            return { between: '' };
        }
    }

    // Load into at-rule mixin for selected content type
    AtRule.prototype.addMixin = function(type) {
        var mixin = type == 'rules' ? Container.WithRules : Container.WithDecls;
        if ( !mixin ) return;

        for ( var name in mixin.prototype ) {
            if ( name == 'constructor' ) continue;
            var value = mixin.prototype[name];

            var container = Container.prototype[name] == value;
            var detector  = name == 'append' || name == 'prepend';
            if ( container && !detector ) continue;

            this[name] = value;
        }
        mixin.apply(this);
    }

    // Stringify at-rule
    AtRule.prototype.stringify = function(builder, last) {
        var style = this.style();

        var name   = '@' + this.name;
        var params = this.params ? this.stringifyRaw('params') : '';

        if ( typeof(this.afterName) != 'undefined' ) {
            name += this.afterName;
        } else if ( params ) {
            name += ' ';
        }

        if ( this.rules || this.decls ) {
            this.stringifyBlock(builder, name + params + style.between + '{');

        } else {
            if ( this.before ) builder(this.before);
            var semicolon = (!last || this.semicolon) ? ';' : '';
            builder(name + params + style.between + semicolon, this);
        }
    }

    // Hack to detect container type by child type
    AtRule.prototype.append = function(child) {
        var mixin = child.type == 'decl' ? 'decls' : 'rules';
        this.addMixin(mixin);
        return this.append(child);
    }

    // Hack to detect container type by child type
    AtRule.prototype.prepend = function(child) {
        var mixin = child.type == 'decl' ? 'decls' : 'rules';
        this.addMixin(mixin);
        return this.prepend(child);
    }
;return AtRule;})(Container);

module.exports = AtRule;
